//THIS PROJECT DEVELOPED BY CORNELL ECE 3400 STAFF. PLEASE
//DO NOT REUSE OR DISTRIBUTE THIS CODE WITHOUT PERMISSION
//SPRING 2015

module blockArray (
	clk,
	r_index,
	w_index,
	value,
	w_en,
	out
);

input clk;
// 7 y bits, 8 x bits for 4x4 blocks
input [14:0] r_index; //x&y coords 
input [14:0] w_index; //x&y coords
input [7:0] value; //write value
input w_en; //write enable
// 8 bit color value
output [7:0] out; //gives r_index's value

reg [7:0] array[19199:0]; //data array 640x480/16
reg [7:0] pre_out; //since out value is a wire

always @(posedge clk) begin
	if (w_en == 1) begin //write value
		array[w_index] <= value;
	end
	pre_out <= array[r_index]; // can use M9K
end

assign out = pre_out; // can use M9K
//assign out = array[r_index]; // forces logic memory
endmodule
